/* include files */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include "search.h"
#include "proc_ora.h"
#include "redirections.h"
#include "text_str.h"
#include <sys/types.h>

extern void create_top(char *,char*,char*);
extern void build(int,int);
extern char *print();

long times_ex[20];

/* procedures that read parameters in cgi form from input */

long  *params_table;	/* table of indexes to parameters */
char  *buffer;	        /* input string till first blank  */

/* procedure read_params				  */
/* it reads characters from input until first blank	  */
/* and then replaces & characters with EOS characters	  */
/* and creates table of indexes to substrings		  */

int   read_params()
{
  long  tab_size=16,para_num=0,i=0,buflen=4096;
  int   c;

  if(strcmp(getenv("REQUEST_METHOD"),"GET")==0)
  {
    buffer=(char*)malloc(strlen(getenv("QUERY_STRING"))+1);
    strcpy(buffer,getenv("QUERY_STRING"));
  }
  else
  {
    buffer=(char*)malloc(buflen);
    while((c=getchar())>' ')
    {
      if(i>buflen)
	buffer=(char*) realloc(buffer,buflen+=4096);
      buffer[i++]=(char)c;
    }
    buffer[i]='\0';
    buffer=(char*) realloc(buffer,strlen(buffer)+1);
  }
  for(i=0,para_num=1;i<strlen(buffer);i++)
    if(buffer[i]=='&') para_num++;
  
  params_table=(long*)malloc(sizeof(long )*(para_num+1));
  params_table[0]=0;
  for(i=0,para_num=1;buffer[i]!='\0';i++)
  {
    if(buffer[i]=='&')
    {
      params_table[para_num++]=i+1;
      buffer[i]='\0';
    }
    if(buffer[i]=='+') buffer[i]=' ';
  }
  params_table[para_num]=-1;
}

char* get_param_val(char* str)
{
  long i;
  static char name[256];

  strcpy(name,str);
  strcat(name,"=");
  for(i=0;params_table[i]>=0;i++)
  {
    if(strncmp(buffer+params_table[i],name,strlen(name))==0)
    {
      char* pt=buffer+params_table[i]+strlen(name);
      buffer[params_table[i]]='\0';
      while(*pt==' ') pt++;
      while(pt[strlen(pt)-1]==' ') pt[strlen(pt)-1]='\0';
      return pt;
    }
  }
  return NULL;
}
  
free_params()
{
  free(buffer);
  free(params_table);
}

long get_option(char* option_name, params* conv_table)
{
  char* param;  
  long   i,option=0;
  
  while((param=get_param_val(option_name))!=NULL)
  {
    for(i=0 ;conv_table[i].param != NULL && i<100 ;i++)
      if(strcmp(conv_table[i].param,param)==0)
      {
	option |= conv_table[i].value;
	break;
      }
  }
  return option;    
}

int check_option(char* name, char* value) 
{
  char* param_val=get_param_val(name);
  if(param_val==NULL) return 0;
  if(strcmp(param_val,value)==0)
    return 1;
  return 0;
}

/**************************************************************/


int next(global_params *glp,unsigned long *hitlst)
{
  find_nxt_hits(hitlst,glp);
  return 0;
};

int normal(global_params *glp,unsigned long *hitlst)
{
  char * query_string;
  create_top(glp->query_text,glp->document,glp->query_ID);
  if(!(glp->options & CONTAINS)) build(NOT_EXPR,glp->options);
  if(glp->options & PHR_EXPR) build(PHR_EXPR,glp->options);
  if(glp->options & PRX_EXPR) build(PRX_EXPR,glp->proxyd*128+glp->proxyd);
  if(glp->options & AND_EXPR) build(AND_EXPR,glp->options);
  if(!(glp->options & AND_EXPR)) build(OR_EXPR,glp->options);
  if(!(glp->options & (SYN_EXPR | SP_EXPR | FM_EXPR)))
    build(T_EXPR,glp->options | PR_FLAG);
  if(glp->options & SYN_EXPR) build(SYN_EXPR,glp->options);
  if(glp->options & SP_EXPR) build(SP_EXPR,glp->options);
  if(glp->options & FM_EXPR) build(FM_EXPR,glp->options);
  build(RM_NONEX,glp->options);
  query_string=print();
  find_hits(query_string,hitlst,glp);
  remove_top();
  return 0;
}

#define max(a,b) (a>b?a:b)
#define min(a,b) (a<b?a:b)

void cat(char *template_name,...)
{
  va_list argptr;
  int c,i=0;
  va_start(argptr,template_name);
  vprintf(template_name,argptr);
}
    

int output_header(global_params *glp)
{
  static char string[80];
  
  cat(head_str);
  if(glp->options & NEXT_OP)
    printf("%s",retrive_info(glp->query_ID));
  else
    output_info(glp);
/*  cat(home_str); */
  printf("<HR><TABLE  WIDTH=\"100%c\"><TR><td ALIGN=\"LEFT\" WIDTH=\"25%c\">",37,37);
  if(glp->start_number>1)
  {
    int prev_low,prev_high;
    prev_low=max(glp->start_number-glp->maxnum_hits,1);	
    prev_high=min(prev_low+glp->maxnum_hits-1,glp->total_num);
/*    sprintf(string,"Prev %d(%d-%d)",prev_high-prev_low+1,prev_low,prev_high);
    cat(next_prev_str,glp->maxnum_hits,
	max(glp->start_number-glp->maxnum_hits,1),glp->query_ID,string); */
   printf("<a href=\"/cgi-bin/think/ans/search?normal_options=next&max_hits=%d&start_num=%d&queryID=%s\">Prev %d</A> (%d-%d)\n", 
     glp->maxnum_hits,max(glp->start_number-glp->maxnum_hits,1),glp->query_ID, prev_high-prev_low+1,prev_low,prev_high);
  }
   else
     printf("<td align=\"left\"><br>\n");


  printf("<td ALIGN=\"CENTER\"  WIDTH=\"50%c\">Total Items Found: <B>%d</B> ",37,glp->total_num);
  printf("<td ALIGN=\"RIGHT\" WIDTH=\"25%c\">",37);

  if(glp->start_number+glp->maxnum_hits <= glp->total_num)
  {
    int next_low,next_high;
    next_low=glp->start_number+glp->maxnum_hits;
    next_high=min(next_low+glp->maxnum_hits-1,glp->total_num);
/*    sprintf(string,"Next %d(%d-%d)",next_high-next_low+1,next_low,next_high);
    cat(next_prev_str,glp->maxnum_hits,
	glp->start_number+glp->maxnum_hits,glp->query_ID,string); */
    printf("<a href=\"/cgi-bin/think/ans/search?normal_options=next&max_hits=%d&start_num=%d&queryID=%s\">Next %d</A> (%d-%d)\n", glp->maxnum_hits,glp->start_number+glp->maxnum_hits,glp->query_ID, next_high-next_low+1,next_low,next_high);
  }
  else 
      printf("<td align=\"right\"><br>\n");

/*  if(glp->start_number>1)
  {
    sprintf(string,"Begin(1-%d)",min(glp->maxnum_hits,glp->total_num));
    cat(next_prev_str,glp->maxnum_hits,1,glp->query_ID,string);
  }
  if(glp->total_num>glp->start_number+glp->maxnum_hits)
  {
    sprintf(string,"End(%d-%d)",glp->total_num-glp->maxnum_hits+1,glp->total_num);
    cat(next_prev_str,glp->maxnum_hits,glp->total_num-glp->maxnum_hits+1,
	glp->query_ID,string);
  }
  if(glp->total_num>5)printf("[<A HREF=\"#REFINE\">Refine</A>]");
  printf("<br>"); 
  
  printf("Hits per page: ");
  cat(next_prev_str,4,glp->start_number,glp->query_ID,"4");
  cat(next_prev_str,20,glp->start_number,glp->query_ID,"20");  
  cat(next_prev_str,50,glp->start_number,glp->query_ID,"50");	 
  cat(next_prev_str,200,glp->start_number,glp->query_ID,"200"); */
  
  printf("</TABLE>");
   
}

int output_footer(global_params *glp)
{
  static char string[80];
/*  cat(home_str);
  if(glp->start_number>1)
  {
    int prev_low,prev_high;
    prev_low=max(glp->start_number-glp->maxnum_hits,1);	
    prev_high=min(prev_low+glp->maxnum_hits-1,glp->total_num);
    sprintf(string,"Prev %d(%d-%d)",prev_high-prev_low+1,prev_low,prev_high);
    cat(next_prev_str,glp->maxnum_hits,
	max(glp->start_number-glp->maxnum_hits,1),glp->query_ID,string);
  }
  if(glp->start_number+glp->maxnum_hits <= glp->total_num)
  {
    int next_low,next_high;
    next_low=glp->start_number+glp->maxnum_hits;
    next_high=min(next_low+glp->maxnum_hits-1,glp->total_num);
    sprintf(string,"Next %d(%d-%d)",next_high-next_low+1,next_low,next_high);
    cat(next_prev_str,glp->maxnum_hits,
	glp->start_number+glp->maxnum_hits,glp->query_ID,string);
  }  
  if(glp->start_number>1)
  {
    sprintf(string,"Begin(1-%d)",min(glp->maxnum_hits,glp->total_num));
    cat(next_prev_str,glp->maxnum_hits,1,glp->query_ID,string);
  }
  if(glp->total_num>glp->start_number+glp->maxnum_hits)
  {
    sprintf(string,"End(%d-%d)",glp->total_num-glp->maxnum_hits+1,glp->total_num);
    cat(next_prev_str,glp->maxnum_hits,glp->total_num-glp->maxnum_hits,
	glp->query_ID,string);
  }
  printf("<br>");
  
  printf("Hits per page: ");
  cat(next_prev_str,4,glp->start_number,glp->query_ID,"4");
  cat(next_prev_str,20,glp->start_number,glp->query_ID,"20");  
  cat(next_prev_str,50,glp->start_number,glp->query_ID,"50");	 
  cat(next_prev_str,200,glp->start_number,glp->query_ID,"200"); 
  if(glp->total_num>5)cat(refine_str, glp->query_ID, glp->maxnum_hits); */
  cat(refine_str, glp->query_ID,glp->maxnum_hits);
  cat(foot_str);
}

void main(int argc,char **argv)
{
  char		 *proxy;
  int		 i;
  char           *submit_option, *temp, *main_mode;
  global_params   gl_params;
  unsigned long  *hitlst;
  static params normal_params[]=
  {{"forw_st",FT},{"back_st",BT},{"soundex",SP_EXPR},
   {"both_st",FT | BT},{"fuzzy",FM_EXPR},{"synon",SYN_EXPR},
   {"case_s",CASE_SENS},{"and",AND_EXPR},{"contains",CONTAINS},
   {"proxy",PRX_EXPR},{"phrase",PHR_EXPR},{"next",NEXT_OP},{NULL,0}};

  stdout_to_info();
  read_params();
  if(getenv("ORACLE_HOME")==NULL) putenv("ORACLE_HOME=/usr/oracle");
  if(getenv("ORACLE_SID")==NULL) putenv("ORACLE_SID=nodb");
  
  gl_params.options     =get_option("normal_options",normal_params);
  gl_params.options    |=get_option("mode",normal_params);
  gl_params.maxnum_hits =atoi(temp=get_param_val("max_hits"));
  gl_params.start_number=atoi(temp=get_param_val("start_num"));
  gl_params.query_text  =get_param_val("query_text");
  /* make query text case insensitive */
  for (temp=gl_params.query_text;*temp != '\0';temp++) *temp=tolower(*temp);
  gl_params.document	=get_param_val("document");
  gl_params.query_ID	=get_param_val("queryID");
  submit_option         =get_param_val("subm_option");
  gl_params.proxy1      =get_param_val("proxy1");
  gl_params.proxy2	=get_param_val("proxy2");
  gl_params.proxyd      =atoi(get_param_val("proxyd"));
  if(gl_params.options & PRX_EXPR)
  {
    proxy=(char*)malloc(strlen(gl_params.proxy1)+strlen(gl_params.proxy2)+16);
    strcpy(proxy,gl_params.proxy1);
    strcat(proxy," ");
    strcat(proxy,gl_params.proxy2);
    gl_params.query_text=proxy;
  }
  
  hitlst	    	=(unsigned long*)malloc(
			    (gl_params.maxnum_hits+2)*sizeof(long));
  init_sql();

  if(gl_params.options & NEXT_OP)
    next(&gl_params,hitlst);
  else
    normal(&gl_params,hitlst);

  stdout_to_stdout();

 
  output_header(&gl_params);
  output_body(hitlst,&gl_params);
  output_footer(&gl_params);
  free(hitlst);
  free_params();
  fflush(stdout);
/* the following two lines gave seg. fault */
/* stdout_to_null();*/
/*  end_sql();*/
  exit;
}
