#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

static char * buffer=NULL;
static int    buf_position=0;
static int    buf_length=0;
static int    buf_cont_len=0;

void zero_buffer()
{
  if(buffer!=NULL) free(buffer);
  buffer=NULL;
  buf_position=0;
  buf_length=0;
  buf_cont_len=0;
}

void reset_buffer()
{
  buf_position=0;
}

int add_to_buffer(char * string, int length)
{
  if(buffer==NULL)
  {
    buf_length=4096;
    buffer=(char*)malloc(buf_length);
    if(buffer==NULL)
    {
      printf("Couldn't allocate memory. Exiting\n");
      return -1;
    }
  }
  if(buf_cont_len+length>=buf_length)
  {
    do buf_length=buf_length+buf_length;
    while(buf_cont_len+length>buf_length);
    buffer=realloc(buffer,buf_length);
    if(buffer==NULL)
    {
      printf("Couldn't reallocate memory. Exiting\n");
      return -1;
    }
  }
  memcpy(buffer+buf_cont_len,string,length);
  buf_cont_len+=length;
  return 0;
}
  
int write_buffer(FILE * f)
{
  if(buffer==NULL) return -1;
  return fwrite(buffer,1,buf_cont_len,f);
}

int get_character()
{
  if(buf_position<buf_cont_len && buffer!=NULL)
    return (buffer[buf_position++]);
  return EOF;
}
  
