#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/sem.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <time.h>

#define URL      2
#define NEXT     3
#define ADD_ADDR 4
extern int errno;
struct timeval timeout={500,0};

struct url_str
{
  long  fid;
  long  hid;
  int	depth;
  char  prot[10];
  char  host[60];
  char  path[255];
};


typedef struct head_info
{
  struct date
  {
    int day;
    int mon;
    int year;
  } date,ltime;
  char   encoding[80];
  long   length;
  char	 ctype[80];
  int	 code;
  int   nr_html,nr_refs,nr_imgs,is_form;
  char	title[255],subject[512];
} head_info;

struct sellist
{
  int fdsmask[1];
};

#define error(str) \
{\
   fprintf(stderr,"%s\n",str); \
   if(shutdown(sock,2)!=0) printf("ERROR SHUT SOCKET\n"); \
   if(close(sock)!=0) printf("ERROR CLOSING SOCK\n"); \
   return 1; \
}
   
static char header[4096];
static int semid, msgid, msgida;
static char rtd_filename[]="/home/T11D/tapulika/think/final_projs/gather/tmp/urls.tmp";
static long key=989690581l;

/* This procedure gets a document from http server */
/* It stores document in file, while its header    */
/* is stored in header variable			   */

int load_doc(struct url_str *url, char* header)
{
  char  prot[10], host[60], path[255], *tmp, *point;
  char  qstring[530];
  int   sock,length,port=80,urllen,i,fl;
  struct sockaddr_in server;
  struct hostent     *hp;
  enum rd_st {HEADER,BODY} rd_st=HEADER;
  struct sellist rsl,wsl,esl;
  int retval, len=0;

  zero_buffer();
  strcpy(prot,url->prot);
  strcpy(host,url->host);
  strcpy(path,url->path);
  if((tmp = strchr(host , ':'))!=NULL)
  {
    *tmp++=0;			/* read port here if given	    */
    port=atoi(tmp);		/* otherwise assume 80		    */
  }

  sock=socket(AF_INET,SOCK_STREAM,PF_NS);	/* create a socket  */
  if (sock<0) error("Couldn't create socket");  
  server.sin_family = AF_INET;			/* create server    */
  server.sin_len = sizeof(server);		/* structure	    */
  hp = gethostbyname(host);
  if (hp == NULL) error("Couldn't get hostname");
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  server.sin_port = htons(port);
  if (connect(sock, &server, sizeof(server))!=0) /* connect to http      */
    error("Couldn't connect");			/* server	        */

  if(sock>4) {
    printf("%d high socket number\n",sock);
    sleep(5);
  }
  if(sock>7) exit();
  rsl.fdsmask[0]=0;
  wsl.fdsmask[0]=1<<sock;
  esl.fdsmask[0]=1<<sock;
  
  if(select(sock+1,&rsl,&wsl,&esl, &timeout)<=0)
    error("Couldn't write to socket");		/* check if can write   */
  if(path[0]=='/')
    sprintf(qstring,
      "GET %s HTTP/1.1\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
      path);                /* make the request     */
  else 
    sprintf(qstring,
	  "GET /%s HTTP/1.1\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
	  path);				/* make the request     */
  if(write(sock,qstring,strlen(qstring))!=strlen(qstring))
    error("Error while writing to socket");     /* write request to sock*/

  /* get document						*/
  strcpy(header,"");

  rsl.fdsmask[0]=1<<sock;
  wsl.fdsmask[0]=0;
  esl.fdsmask[0]=1<<sock;

  do
  {
    if(select(sock+1,&rsl,NULL,&esl, &timeout)<=0)
      error("Can't read from socket");       /* check if ready for read */
    retval=read(sock,qstring,512);
    if(retval<0) error("Error occured when reading from socket");
    if(rd_st == HEADER)
    {
      if(strlen(header)>4096-512)
	error("Too long header");
      qstring[retval]='\0';
      strcat(header,qstring);
      if((point=strstr(header,"\n\n")) || (point=strstr(header,"\r\r")) ||
	 (point=strstr(header,"\r\n\r\n")))
      {
	*point='\0';
	if(add_to_buffer(point+2,strlen(point+2)))
	  error("Error occured buffering document");
	rd_st=BODY;
	len=retval-(point-header)+2;
      }
    }
    else
    {
      if(add_to_buffer(qstring,retval)!=0)
	error("Error occured buffering document");
      len+=retval;
    }
  }
  while(retval!=0);
  if(shutdown(sock,2)!=0) printf("ERROR SHUTDOWN SOCKET \n");
  if(close(sock)!=0) printf("ERROR CLOSING SOCKET \n");   /* closing of a socket and exiting without    */
  return len;    	  /* error code					*/
}

int mon_num(char* str)
{
  if(strcmp(str,"jan")==0) return 1;
  if(strcmp(str,"feb")==0) return 2;
  if(strcmp(str,"mar")==0) return 3;
  if(strcmp(str,"apr")==0) return 4;
  if(strcmp(str,"may")==0) return 5;
  if(strcmp(str,"jun")==0) return 6;
  if(strcmp(str,"jul")==0) return 7;
  if(strcmp(str,"aug")==0) return 8;
  if(strcmp(str,"sep")==0) return 9;
  if(strcmp(str,"oct")==0) return 10;
  if(strcmp(str,"nov")==0) return 11;
  if(strcmp(str,"dec")==0) return 12;
  return 0;
}

char* num_mon(int nr)
{
  static char str[5];
  switch(nr)
  {
  case 1:	strcpy(str,"jan"); break;
  case 2:	strcpy(str,"feb"); break;
  case 3:	strcpy(str,"mar"); break;
  case 4:	strcpy(str,"apr"); break;
  case 5:	strcpy(str,"may"); break;  
  case 6:	strcpy(str,"jun"); break;
  case 7:	strcpy(str,"jul"); break;
  case 8:	strcpy(str,"aug"); break;
  case 9:	strcpy(str,"sep"); break;
  case 10:	strcpy(str,"oct"); break;
  case 11:	strcpy(str,"nov"); break;
  case 12:	strcpy(str,"dec"); break;
  default:	strcpy(str,"jan");
  }
  return str;
}
  


void remove_blanks(char* str)
{
  int n,len,i=0;
  len=strlen(str);
  for(i=0;i<len;i++)
    if(str[i]<' ' || str[i]>'z') str[i]=' ';
  i=0;
  while(str[i]==' ') i++;
  len=len-i;
  for(n=0;n<=len;n++)
    str[n]=str[n+i];
  while(len!=0 && str[--len]==' ')str[len]='\0';
}

char* chk_href(char* str)
{
  static char href[256];
  char * tmp=NULL;
  int	 poiner_a,length,i;
  enum {NORM, QUOT} state=NORM;
  
  while(*str==' ' || *str=='\t' || *str=='\n') str++;
  if(*str != 'a' && *str != 'A') return 0;
  str++;
  if(*str!=' ' && *str!='\t' && *str!='\n') return 0;

  for(;*str!=0;str++)
  {
    if(*str=='"')
    {
      if(state==NORM) state=QUOT;
      if(state==QUOT) state=NORM;
    }
    if(state==QUOT) continue;
    if(*str>' ' || *str=='\0') continue; else str++;
    if(*str!='h' && *str!='H') continue; else str++;
    if(*str!='r' && *str!='R') continue; else str++;
    if(*str!='e' && *str!='E') continue; else str++;
    if(*str!='f' && *str!='F') continue; else str++;
    break;
  }
  if(*str=='\0') return NULL;
  while(*str!='=' && *str!='\0') str++;
  str++;
  while(*str<=' ' && *str!='\0') str++;
  if(*str=='"') str++;
  tmp=href;
  while(*str!=' ' && *str!='"' && *str!='\0')
  {
    if(tmp-href>254) return NULL;
    *tmp++=*str++;
  }
  *tmp='\0';
  return href;
}
    
int chk_html(char* href)
{
  char *ext;
  int length=strlen(href);
  if(href[length-1]=='/') return 1;
  ext=strrchr(href,'.');
  if(strcmp(ext,".html")==0) return 1;
  if(strcmp(ext,".htm")==0) return 1;
  if(strcmp(ext,".ht")==0) return 1;
  return 0;
}
  
int chk_img(char* str)
{
  while(*str<' ' && *str != 0) str++;
  if(str[0]!='I' && str[0]!='i') return 0;
  if(str[1]!='M' && str[1]!='m') return 0;
  if(str[2]!='G' && str[2]!='g') return 0;
  return 1;
}
      
int chk_title(char* str)
{
  static char buffer[255];
  int length;
  while(*str<' ' && *str != 0) str++;
  if(str[0]!='T' && str[0]!='t') return 0;
  if(str[1]!='I' && str[1]!='i') return 0;
  if(str[2]!='T' && str[2]!='t') return 0;
  if(str[3]!='L' && str[3]!='l') return 0;
  if(str[4]!='E' && str[4]!='e') return 0;
  return 1;
}
  
int chk_etitle(char* str)
{
  static char buffer[255];
  int length;
  while(*str<' ' && *str != 0) str++;
  if(str[0]!='/') return 0;
  if(str[1]!='T' && str[1]!='t') return 0;
  if(str[2]!='I' && str[2]!='i') return 0;
  if(str[3]!='T' && str[3]!='t') return 0;
  if(str[4]!='L' && str[4]!='l') return 0;
  if(str[5]!='E' && str[5]!='e') return 0;
  return 1;
}  

int chk_form(char* str)
{
  static char buffer[255];
  int length;
  while(*str<' ' && *str != 0) str++;
  if(str[1]!='F' && str[1]!='f') return 0;
  if(str[2]!='O' && str[2]!='o') return 0;
  if(str[3]!='R' && str[3]!='r') return 0;
  if(str[4]!='M' && str[4]!='m') return 0;
  return 1;
}

process_header(char* header,head_info* hi)
{
  int   i,head_len=strlen(header);
  char* line;

    
  for(i=0;i<head_len;i++)
    header[i]=tolower(header[i]);
  do
  {
    line=header;
    header=strchr(header,'\n');
    if(header) *header++='\0';

    if(strncmp("http",line,4)==0)
    {
      if((line=strchr(line,' '))==NULL) continue;
      hi->code=atoi(line);
      continue;
    }
    if(strncmp("content-length",line,14)==0)
    {
      if((line=strchr(line,' '))==NULL) continue;
      hi->length=atoi(line);
      continue;
    }
    if(strncmp("content-type",line,9)==0)
    {
      if(line=strchr(line,':')) line++; else continue;
      strcpy(hi->ctype,line);
      continue;
    }
    if(strncmp("last-modified",line,13)==0)
    {
      char *day,*mon,*year;
      if(line=strchr(line,':')) line++; else continue;
      while((*line<'0' || *line>'9') && *line!=0) line++;
      day=line;
      while(*line>='0' && *line<='9' && *line!=0) line++;
      if(*line !=0) *line++=0;
      while((*line<'a' || *line>'z') && *line!=0) line++;
      mon=line;
      while(*line>='a' && *line<='z' && *line!=0) line++;
      if(*line !=0) *line++=0;
      while((*line<'0' || *line>'9') && *line!=0) line++;
      year=line;
      while(*line>='0' && *line<='9' && *line!=0) line++;
      if(*line !=0) *line++=0;
      hi->date.day=atoi(day);
      hi->date.mon=mon_num(mon);
      hi->date.year=atoi(year);
      if(hi->date.year<1900) hi->date.year+=1900;
    }
  }
  while(header);
}

char* calculate_address(char* href, struct url_str *old_url, struct url_str *new_url)
{
  char *point;
  char *point1,*point2;
  int  protf=0,hostf=0,pathf=0,n;

  new_url->prot[0]=0;
  new_url->host[0]=0;
  new_url->path[0]=0;
  if(strchr(href,'?')) return NULL;
  if(strchr(href,'&')) return NULL;

  while(*href<=' ' && *href!='\0') href++;
  point1=strchr(href,':');
  point2=strchr(href,'/');
  if(point1!=NULL && (point2==NULL || point1<point2))
  {
    *point1='\0';
    protf=1;
    strcpy(new_url->prot,href);
    href=point1+1;
  }
  point1=NULL; 
  if(point1=strstr(href,"//"))
  {
    point1+=2;
    point2=strchr(point1,'/');
    if(point2==NULL) point2=point1+strlen(point1);
    href=point2;
    if(*href!='\0') href++;
    *point2='\0';
    strcpy(new_url->host,point1);
    if(point=strchr(new_url->host,':'))
    {
      int i;
      sscanf(point+1,"%d",&i);
      if(i==80) *point='\0';
    }
    hostf=1;
  }
  strcpy(new_url->path,href);
  if(protf==0) strcpy(new_url->prot,old_url->prot);
  if(hostf==0)
  {
    strcpy(new_url->host,old_url->host);
    if(new_url->path[0]!='/')
    {
      char old_path[255],*point;
      strcpy(old_path,old_url->path);
      point=strrchr(old_path,'/');
      if(point==NULL)
	strcpy(old_path,"");
      else
	*point='\0';
      strcat(old_path,"/");
      strcat(old_path,new_url->path);
      strcpy(new_url->path,old_path);
    }
  }
  while(point=strstr(new_url->path,"/../"))
  {
    char* i=point;
    int   n;
    *i=0;
    if((i=strrchr(new_url->path,'/'))==NULL) i=new_url->path; else i++;
    n=point+4-i;
    do
    {
      *i=*(i+n);
    }
    while(*(i++)!=0);
  }
  while(point=strstr(new_url->path,"./"))
  {
    char* i=point;
    do
    {
      *i=*(i+2);
    }
    while(*(i++)!=0);
  }
  if(point=strchr(new_url->path,'#')) *point='\0';
  if(*(new_url->path)!='/')
    for(n=strlen(new_url->path)+1;n>0;n--) new_url->path[n]=new_url->path[n-1];
  *(new_url->path)='/';
  return href;
}

void add_address(struct url_str *url,char* href)
{
  int l;
  struct sembuf sb={1,-1,0};
  struct url_str new_url;
  struct
  {
    long type;
    long  depth;
    long  host;
    long  path;
    char msg[255];
  } mb;
  if((href=calculate_address(href,url,&new_url))==NULL) return;
  mb.type=ADD_ADDR;
  mb.depth=url->depth+1;
  mb.host=strlen(new_url.prot)+1;
  mb.path=mb.host+strlen(new_url.host)+1;
  strcpy(mb.msg,new_url.prot);
  strcpy(mb.msg+mb.host,new_url.host);
  strcpy(mb.msg+mb.path,new_url.path);
  semop(semid,&sb,1);  
  l=strlen(new_url.path)+mb.path+3*sizeof(long)+1;
  printf("*");
  msgsnd(msgida,&mb,l,0);
}

int get_url_info(struct url_str *url, head_info *hi)
{
  int  string_len=0,c,i;
  int  state=0;
  char string[4096];
  char *href,*point;
  int  title_len=0,subject_len=0;
  long ltime;
  struct tm  *gmt;
#define ST_L  1
#define TITLE 2
#define SUBJ  4
  reset_buffer();
  while((c=get_character())!=EOF)
  {
    if(state & ST_L)
    {
      if(c!='>' && string_len<4095) 
	string[string_len++]=c;
      else
	if(c=='>')
	{
	  string[string_len]=0;
	  if(href=chk_href(string))
	  {
	    hi->nr_refs++;
	    if(chk_html(href)) hi->nr_html++;
	    add_address(url,href);
	  }
	  else if(chk_img(string))   hi->nr_imgs++;
	  else if(chk_form(string))  hi->is_form=1;
	  else if(chk_title(string)) state |= TITLE;
	  else if(chk_etitle(string))state &= ~TITLE;
	  state &= ~ST_L;
	  string_len=0;
	}
    }
    else
    {
      if(c=='<')
      {
	state |= ST_L;
	continue;
      }
      if(state & TITLE && title_len<255)
      {
	if(c > ' ')
	{
	  if(c=='\'') c='"';
	  hi->title[title_len++]=c;
	}
	else
	  if(title_len>0 && hi->title[title_len-1] > ' ')
	    hi->title[title_len++]=' ';
	continue;
      }
      if(subject_len<512)
	if(c > ' ')
	{
	  if(c=='\'') c='"';
	  hi->subject[subject_len++]=c;
	}
	else
	  if(subject_len>0 && hi->subject[subject_len-1] > ' ')
	    hi->subject[subject_len++]=' ';
    }
  }
  hi->title[title_len]='\0';
  hi->subject[subject_len]='\0';
  remove_blanks(hi->title);
  remove_blanks(hi->subject);
  if(hi->title[0]=='\0') strcpy(hi->title,"No title"); 
  if(point=strstr(hi->subject,hi->title))
    strcpy(hi->subject,point+strlen(hi->title));
  hi->subject[255]='\0';
  if(point=strrchr(hi->subject,' ')) *point='\0';
  
  ltime=time(0);
  gmt=gmtime(&ltime);
  hi->ltime.day=gmt->tm_mday;
  hi->ltime.mon=gmt->tm_mon;
  hi->ltime.year=gmt->tm_year+1900;
  if(hi->date.year==0) memcpy(&(hi->date),&(hi->ltime),sizeof(hi->ltime));
}


int process_url(struct url_str *url)
{
  char        buffer[256],date[12];
  FILE        *file,*rtd_file;
  static char string[4096];
  int	      i=0;

  struct sembuf sba={0,-1,0},sbb={0,1,0};
  int	      c;
  head_info   hi={{0,0,0},{0,0,0},"",0,"",0,0,0,0,0,"",""};
  if(!(hi.length=load_doc(url,header)))
  {	
    printf("Couldn't load document\n");
    /*fclose(file);*/
    return 1;
  }
  process_header(header,&hi);
  if(hi.code != 200)
  {
    printf("failed at process_header\n");
     /*fclose(file); */
    return 1;
  }
  get_url_info(url,&hi);
  semop(semid,&sba,0);
  if(!(rtd_file=fopen(rtd_filename,"a")))
    {
      printf("couldn't open rtd_file\n");
       /*fclose(file); */
      return 1;
    }
  fprintf(rtd_file, "<TEXTSTART: ");
  if(url->fid!=0)  fprintf(rtd_file,"FID=%ld,",url->fid);
  fprintf(rtd_file, "HOST_ID=%d,PROT='%s',",url->hid,url->prot);
  fprintf(rtd_file, "HOST='%s',PATH='%s',",url->host,url->path);
  fprintf(rtd_file, "FSIZE=%d,",hi.length);
  fprintf(rtd_file, "TIME=%d-%s-%d,",hi.date.day,num_mon(hi.date.mon),hi.date.year);
  fprintf(rtd_file, "LTIME=%d-%s-",hi.ltime.day,num_mon(hi.ltime.mon));
  fprintf(rtd_file, "%d,",hi.ltime.year);
  fprintf(rtd_file, "NO_REFS=%d,NO_HTML=%d,STATUS=0,",hi.nr_refs,hi.nr_html);
  fprintf(rtd_file, "NO_IMGS=%d,S_FORM=%d,",hi.nr_imgs,hi.is_form);
  fprintf(rtd_file, "TITLE='%s',SUBJECT='%s'>\n",hi.title,hi.subject);

  write_buffer(rtd_file);
  fprintf(rtd_file, "\n<TEXTEND>\n");
  fclose(rtd_file);
  semop(semid,&sbb,0);
   /*fclose(file);*/
  return 0;
}


main()
{
  struct msgbuf
  {
    long msgid;
    long fid;
    long hid_flag;
    long depth;
    long host_offset;
    long path_offset;
    char msg[255];
  } mb={0,0,0,0,0,0,""};
  struct url_str url;
  int len=20;
  msgid=msgget(key,0);
  semid=semget(key,2,0);
  msgida=msgget(key+1,0);
  if(msgid <=0 || semid <=0 || msgida <=0)
  {
    printf("couldn't open semaphores or messages");
    exit();
  }
  while(1)
  {
    mb.msgid=NEXT;
    if(msgsnd(msgid, &mb, len, 0)) continue;
    if((len=msgrcv(msgid, &mb, sizeof(mb), URL, 0))<=0) continue;
    strcpy(url.prot,mb.msg);
    strcpy(url.host,mb.msg+mb.host_offset);
    strcpy(url.path,mb.msg+mb.path_offset);
    url.hid=mb.hid_flag;
    url.fid=mb.fid;
    url.depth=mb.depth;
    printf("\nPROCESSING: %ld %s %s %s\n",url.fid,url.prot,url.host,url.path);
    mb.fid=process_url(&url);
    printf("\nfid is  %ld \n",mb.fid);
  }
}



