rem
rem
Rem  Copyright (c) 1995 by Oracle Corporation
Rem    NAME
Rem      owa.sql - package of procedures called directly from OWA
Rem    DESCRIPTION
Rem      This file contains one package:
Rem         owa     - These procedures are interface procedures for
Rem                     the Oracle Web Agent.  These procedures should
Rem                     not be called by an end-user.
Rem
Rem    NOTES
Rem      The Oracle Web Agent is needed to use these facilities.
Rem      The package htp is needed to use these facilities.
Rem
Rem    MODIFIED   (MM/DD/YY)
Rem     mbookman   07/09/95 -  Creation

REM Creating OWA package...
create or replace package OWA is

   type vc_arr is table of varchar2(2000) index by binary_integer;

   cgi_var_name vc_arr;
   cgi_var_val  vc_arr;

   auth_type varchar2(100);
   gateway_interface varchar2(100);
   http_user_agent varchar2(100);
   remote_host varchar2(100);
   remote_addr varchar2(100);
   remote_user varchar2(100);
   remote_ident varchar2(100);
   server_protocol varchar2(100);
   server_software varchar2(100);
   server_name varchar2(100);
   server_port varchar2(100);


     /********************************************/
    /* Initialize the CGI environment variables */
   /********************************************/
   procedure init_cgi_env (num_params in number,
                           param_name in vc_arr,
                           param_val  in vc_arr);

     /********************************************/
    /* Initialize the WOW-CGI environment variables */
   /********************************************/
   procedure init_cgi_env_wow ( xAUTH_TYPE in varchar2,
                            xGATEWAY_INTERFACE in varchar2,
                            xHTTP_USER_AGENT in varchar2,
                            xREMOTE_HOST in varchar2,
                            xREMOTE_ADDR in varchar2,
                            xREMOTE_USER in varchar2,
                            xREMOTE_IDENT in varchar2,
                            xSERVER_PROTOCOL in varchar2,
                            xSERVER_SOFTWARE in varchar2,
                            xSERVER_NAME in varchar2,
                            xSERVER_PORT in varchar2
                          );


     /*****************************************/
    /* Get the output from the user's PL/SQL */
   /*****************************************/
   procedure get_page (thepage     out htp.htbuf_arr,
                       irows    in out integer );

    /**************************************************************/
    /* Procedure/function for accessing CGI environment variables */
   /**************************************************************/
   /* GET_CGI_ENV will return the value of the requested CGI     */
   /* environment variable, or NULL if that value is not set.    */
   function  get_cgi_env(param_name in varchar2) return varchar2;

   /* PRINT_CGI_ENV will print all of the CGI environment        */
   /* variables which OWA has made available to PL/SQL.          */
   procedure print_cgi_env;

   /* Jiangang's stuff */
   function get_value(name in varchar2, which in number) return varchar2;
   function get_length(name in varchar2) return number;
   function get_next(name in out varchar2) return number;

end;
/
show errors
