drop package stats;
/
create or replace package stats is
procedure stats;
procedure summary;
procedure dbsummary;
procedure showvisitors;
procedure visitor_today;
procedure visitors;
procedure who(host varchar2,tot number);
procedure announce(hostname varchar2,name varchar2);
procedure by_date(tot number);
procedure browser(tot number);
function url(curl in varchar2, cname in varchar2) return varchar2;
  owner_uid constant varchar2(10) := 'think';
  cgi_bin constant varchar2(30) := '/cgi-bin/'||owner_uid||'/wow/';

  end;
/
show errors;
/
create or replace package body stats is

function url    (curl   in varchar2, cname   in varchar2) return varchar2 is
begin return('<a href="' || curl || '">' || cname || '</a>'); end;

procedure summary is

total number(6);
min_time date;
now date;
today number(5);
begin
	select count(*) into total from env_table;
	select min(ttime) into min_time from env_table;
	htp.title('Summary of Visitors Access Information');
	htp.p('<h1>Summary of Visitors Access Information</h1>');
	htp.p('<center><table border=1 width="100%">');
	htp.p('<tr><td>Total Visits <td>'||url(cgi_bin||'stats.showvisitors',htf.bold(total)));
	select count(*) into today from env_table where ttime >=to_date(to_char(sysdate,'ddmmyy'),'ddmmyy');
	htp.p('<tr><td>Total Today''s Visits <td>'||url(cgi_bin||'stats.visitor_today',htf.bold(today)));
	htp.p('<tr><td>Visits counts by days <td>'||
		url(cgi_bin||'stats.by_date?tot='||total,'days'));
	select count(distinct remote_host) into total from env_table;
	htp.p('<tr><td>Total Unique Visitors (counted by IP address) <td>'||
		url(cgi_bin||'stats.visitors',htf.bold(total)));
	select count(distinct substr(http_user_agent,1,4)) into total from env_table;
	htp.p('<tr><td>Total Web Browser Types <td>'||url(cgi_bin||'stats.browser?tot='||total,htf.bold(total)));
	htp.p('<tr><td>Database Size<td>'||url(cgi_bin||'stats.dbsummary','Click here'));
	htp.p('<tr><td>Accounting Time Period <td> <i>'||to_char(min_time,'mm/dd/yy hh24:mi')||
		' - now ('||to_char(sysdate,'mm/dd/yy hh24:mi')||' EST)</i>');
	htp.p('</table><center>');
	wow.sig;
end;

procedure dbsummary is
total number(8);
ncount number(8);
begin
	htp.p('<center><table border=1 align="center" width="100%">');
	htp.p('<caption><font size="+2">Summary of current database size</font></caption>');
 	htp.p('<tr align="center"><th>Category<th>Size (KB)<th>No. of Proposals');
	select sum(fsize)/1024.,count(*) into total,ncount from search;
	htp.p('<tr align="center"><td>Total<td>'||total||'<td>'||ncount);
	select sum(fsize)/1024.,count(*) into total,ncount from search where
		ftype=1;
	htp.p('<tr align="center"><td>Science and Math<td>'||total||'<td>'||ncount);
	select sum(fsize)/1024.,count(*) into total,ncount from search where
		ftype=2;
	htp.p('<tr align="center"><td>Arts and Literature<td>'||total||'<td>'||ncount);
	select sum(fsize)/1024.,count(*) into total,ncount from search where
		ftype=3;
	htp.p('<tr align="center"><td>Social Science<td>'||total||'<td>'||ncount);
	select sum(fsize)/1024.,count(*) into total,ncount from search where
		ftype=4;
	htp.p('<tr align="center"><td>Sports<td>'||total||'<td>'||ncount);
	select sum(fsize)/1024.,count(*) into total,ncount from search where
		ftype=5;
	htp.p('<tr align="center"><td>Interdisciplinary<td>'||total||'<td>'||ncount);
	htp.p('</table><center>');
	wow.sig;
end;

procedure browser(tot number) is
	cursor cbrowser is select substr(http_user_agent,1,4),count(*) from env_table 
	   group by substr(http_user_agent,1,4) order by 2 desc, 1 asc;
	btype varchar2(10);
	browser varchar2(100);
	total number(6);
begin
	htp.htitle('Web Browser Types of the User Community');
	htp.p('<ul>');
	htp.p('<li>Total Browsers: '||htf.bold(tot));
	htp.p('<ol>');
	open cbrowser;
	loop
		fetch cbrowser into btype,total;
		exit when cbrowser%NOTFOUND;
		if (replace(btype,' ') IS NULL) then
			browser := 'Unknown';
		else
			select http_user_agent into browser from env_table where 
			http_user_agent like btype||'%' and rownum=1;
			if (instr(browser,'/',1,1) >0) then
				browser := substr(browser,1,instr(browser,'/',1,1)-1);
			end if;
			if (instr(browser,' ',1,2) >0) then
				browser := substr(browser,1,instr(browser,' ',1,2));
			end if;	
		end if;			
		htp.p('<li>'||htf.bold(browser)||': '||total);
	end loop;
	htp.p('</ol>');
	close cbrowser;
 	select count(*) into total from env_table where http_user_agent like '%X%';
	htp.p('<li>Platforms Types: UNIX ('||total||') ');
	select count(*) into total from env_table where (lower(http_user_agent) like '%win%'
		or lower(http_user_agent) like '%mac%') and http_user_agent not like '%X%';
	htp.p('PC ('||total||')');
	htp.p('<ul>');	
	select count(*) into total from env_table where lower(http_user_agent) like '%sun%';
	htp.p('<li>SUN (SunOS): '||total);
	select count(*) into total from env_table where lower(http_user_agent) like '%irix%';
	htp.p('<li>SGI (IRIX): '||total);
	select count(*) into total from env_table where lower(http_user_agent) like '%aix%';
	htp.p('<li>IBM (AIX): '||total);
	select count(*) into total from env_table where lower(http_user_agent) like '%hp%';
	htp.p('<li>HP (UX): '||total);
	select count(*) into total from env_table where lower(http_user_agent) like '%osf%';
	htp.p('<li>DEC alpha (OSF): '||total);
	select count(*) into total from env_table where lower(http_user_agent) like '%linux%';
	htp.p('<li>Linux: '||total);
	select count(*) into total from env_table where lower(http_user_agent) like '%win%' 
		and http_user_agent not like '%X%';
	htp.p('<li>IBM PC (MS Window): '||total);
	select count(*) into total from env_table where lower(http_user_agent) like '%mac%';
	htp.p('<li>Macintosh: '||total);
	select count(*) into total from env_table where not (lower(http_user_agent) like '%win%'
		or lower(http_user_agent) like '%mac%' or http_user_agent like '%X%');
	htp.p('<li>Unknown platforms: '||total);
	htp.p('</ul>');
	select count(*) into total from env_table where lower(http_user_agent) like '%proxy%';
	htp.p('<li>Total browsers/machines through a firewall: '||htf.bold(total));
	htp.p('</ul>');
	wow.sig;
end;

  procedure showvisitors is
	cursor c_visitor is select ttime,remote_host,http_user_agent from env_table order by ttime desc;
	n number(7) := 0;
	begin
		select count(*) into n from env_table;
		htp.htitle('Total visits to this database');
		htp.p('<center><table border=1 width="100%">');
	 	htp.p('<tr><th>No.<th>Access Time<th>Client Host Name<th>Client Web Browser');
 		n := n + 1;
		for env_table in c_visitor loop
			htp.p('<tr><td>'||to_char(n - c_visitor%ROWCOUNT)||'<td>'||
			to_char(env_table.ttime,'hh24:mi mm/dd/yy')||'<td>'||env_table.remote_host||
			'<td>'||env_table.http_user_agent||'</td>');
		end loop;
		htp.p('</table>');
		htp.p('Total: '||htf.bold(n-1));
		htp.p('</center>');
		wow.sig;
	end;

 procedure visitor_today is
	cursor c_visitor is select ttime,remote_host,http_user_agent from env_table
		where ttime >=to_date(to_char(sysdate,'ddmmyy'),'ddmmyy') order by ttime desc;
	n number(7) := 0;
	begin
		select count(*) into n from env_table
			where ttime >=to_date(to_char(sysdate,'ddmmyy'),'ddmmyy');
		htp.htitle('Visits to this database for today ('||to_char(sysdate,'Day mm/dd/yy')||')');
		htp.p('<center><table border=1 width="100%">');
	 	htp.p('<tr><th>No.<th>Access Time<th>Client Host Name<th>Client Web Browser');
 		n := n + 1;
		for env_table in c_visitor loop
			htp.p('<tr><td>'||to_char(n - c_visitor%ROWCOUNT)||'<td>'||
				to_char(env_table.ttime,'hh24:mi')||'<td>'||env_table.remote_host||
				'<td>'||env_table.http_user_agent||'</td>');
		end loop;
		htp.p('</table>');
		htp.p('Total: '||htf.bold(n-1));
		htp.p('</center>');
		wow.sig;
	end;

procedure visitors is
	cursor cvisitor is select remote_host,count(*) from env_table 
		group by remote_host order by 2 desc, 1 asc;
	total number(6);
	host env_table.remote_host%TYPE;
	begin
	select count(distinct remote_host) into total from env_table;
		htp.htitle('Unique visitors to this database');
		htp.p('<center><table border=1 width="100%">');
	 	htp.p('<tr><th>Remote Host Machine<th>Number of Visits');
 		open cvisitor;
		loop
			fetch cvisitor into host,total; 
			exit when cvisitor%NOTFOUND;
			htp.p('<tr><td>'||host||'<td>'||url(cgi_bin||'stats.who?host='||host||'&tot='||total,
				htf.bold(total)));
		end loop;
		close cvisitor;
		htp.p('</table>');
		htp.p('Total: '||htf.bold(total));
		htp.p('</center>');
		wow.sig;
	end;
procedure who(host varchar2,tot number) is
	cursor c_visitor(ahost varchar2) is select ttime,http_user_agent from env_table 
		where remote_host = ahost order by ttime desc;
	n number(7) := 0;
	--address env_table.remote_addr%TYPE;
	begin
		n := tot;
		htp.htitle('Visiting Information from Host ('||host||')');
		htp.p('<center><table border=1 width="100%">');
		--select remote_addr into address from env_table where remote_host = host and rownum=1;
		
	 	htp.p('<tr><th>No.<th>Access Time<th>Client Web Browser');
 		htp.p(htf.line);
		n := n + 1;
		for env_table in c_visitor(host) loop
		htp.p('<tr><td>'||to_char(n - c_visitor%ROWCOUNT)||'<td>'||
			to_char(env_table.ttime,'hh24:mi mm/dd/yy')||'<td>'||
			env_table.http_user_agent);
		end loop;
		htp.p('</table>');
		htp.p('Total Visits: '||htf.bold(n-1));
		--htp.p('; Client IP Address: '||htf.bold(address));
		htp.p('</center>');
		wow.sig;
	end;

procedure announce(hostname varchar2,name varchar2) is
	total number(6);
	today number(5);
	netter varchar2(30);
	begin
		select  count(*) into total from env_table;
		select count(*) into today from env_table where ttime >=to_date(to_char(sysdate,'ddmmyy'),'ddmmyy');

		if ((name='unknown') or (name IS NULL)) then
			netter := 'netter';
		else
			netter := '<em>'||name||'</em>';
		end if;

	        htp.p('Welcome, '||netter||' from <i>'||hostname||'</i>, you are the '||
			url(cgi_bin||'stats.visitor_today',htf.bold(today))
			||'''th visitor today (total: '||
			url(cgi_bin||'stats.showvisitors',htf.bold(total))||').');
		htp.p(' See all '||
			url(cgi_bin||'stats.summary','visitors history')||'.');
		select count(*) into total from env_table where remote_host=hostname;
		if (total = 1) then
			htp.p('It is your first time visiting us, please read our '||
				url('/disclaim.html','Disclaimer')||'.');
		else
			htp.p('You visited us '||url(cgi_bin||'stats.who?host='||hostname||
			'&tot='||total,total)||' times. ');
			htp.p(url(cgi_bin||'stats.special?host='||hostname||'&tot='||total,'here')||
			' is a piece of special news customized for '||
			url(cgi_bin||'stats.who?host='||hostname||
			'&tot='||total,'you')||' !');
		end if;
	        htp.p(htf.line);
	end;

procedure by_date(tot number) is
	--cursor cdate is select to_char(new_time(ttime,'EST','EST'),'mm-dd, Day'),
		cursor cdate is select to_char(ttime,'mm/dd/yy'),
		count(*) from env_table group by to_char(ttime,'mm/dd/yy') order by 1 desc;
	dday varchar2(30);
	total number(6);
	n integer;
	dmax number(6);
	dmin number(6);
	maxday varchar2(30);
	minday varchar2(30);
begin

	htp.htitle('Visit Counts By Date');
	htp.p('<center><table border=1 width="100%">');
	n := 0;
	dmax := 0;
	dmin := 100000;
	open cdate;
	loop
		fetch cdate into dday,total;
		exit when cdate%NOTFOUND;
		n := n + 1;
		htp.p('<tr><td>'||dday||'<td>'||htf.bold(total));
		if (total > dmax) then
			dmax := total;
			maxday := dday;
		end if;
		if (total < dmin) then
			dmin := total;
			minday := dday;
		end if;
	end loop;
	close cdate;
	htp.p('<tr><td>Total<td>'||tot||'<tr><td>Average<td>'||ceil(tot/n)||'/day');
	htp.p('<tr><td>Maximum<td>'||dmax||' ('||maxday||')<tr><td>Minimum<td>'||dmin||' ('||minday||')');
	htp.p('</table></center>');
	wow.sig;
end;

procedure stats is
	begin
		summary;
	end;
end stats;
/
show errors;
/

